Attribute VB_Name = "mdlExtension"

Option Explicit

Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const REG_SZ = 1 ' Unicode nul terminated string
Private Const REG_BINARY = 3 ' Free form binary
Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HWND_BROADCAST = &HFFFF&
Private Const WM_WININICHANGE = &H1A

Private Sub DelSetting(hKey As Long, strPath As String, strValue As String)
    Dim Ret
    'Create a new key
    RegCreateKey hKey, strPath, Ret
    'Delete the key's value
    RegDeleteValue Ret, strValue
    'close the key
    RegCloseKey Ret
End Sub

Private Sub SaveString(hKey As Long, strPath As String, strValue As String, strData As String)
    Dim Ret
    'Create a new key
    RegCreateKey hKey, strPath, Ret
    'Save a string to the key
    RegSetValueEx Ret, strValue, 0, REG_SZ, ByVal strData, Len(strData)
    'close the key
    RegCloseKey Ret
End Sub

Private Function GetString(hKey As Long, strPath As String, strValue As String)
    Dim Ret
    'Open the key
    RegOpenKey hKey, strPath, Ret
    'Get the key's content
    GetString = RegQueryStringValue(Ret, strValue)
    'Close the key
    RegCloseKey Ret
End Function

Public Function RegQueryStringValue(ByVal hKey As Long, ByVal strValueName As String) As String
    Dim lResult As Long, lValueType As Long, strBuf As String, lDataBufSize As Long
    'retrieve nformation about the key
    lResult = RegQueryValueEx(hKey, strValueName, 0, lValueType, ByVal 0, lDataBufSize)
    If lResult = 0 Then
        If lValueType = REG_SZ Then
            'Create a buffer
            strBuf = String(lDataBufSize, Chr$(0))
            'retrieve the key's content
            lResult = RegQueryValueEx(hKey, strValueName, 0, 0, ByVal strBuf, lDataBufSize)
            If lResult = 0 Then
                'Remove the unnecessary chr$(0)'s
                RegQueryStringValue = Left(strBuf, InStr(1, strBuf, Chr$(0)) - 1)
            End If
        ElseIf lValueType = REG_BINARY Then
            Dim strData As Integer
            'retrieve the key's value
            lResult = RegQueryValueEx(hKey, strValueName, 0, 0, strData, lDataBufSize)
            If lResult = 0 Then
                RegQueryStringValue = strData
            End If
        End If
    End If
End Function

Private Sub ApplyRegChanges()
    PostMessage HWND_BROADCAST, WM_WININICHANGE, 0, 0
End Sub

Public Function sdkEnabled() As Boolean
    sdkEnabled = _
        GetString(HKEY_CLASSES_ROOT, FileType.Path, FileType.Value) = FileType.Data And _
        GetString(HKEY_CLASSES_ROOT, Extension.Path, Extension.Value) = Extension.Data And _
        GetString(HKEY_CLASSES_ROOT, Address.Path, Address.Value) = Address.Data And _
        GetString(HKEY_CLASSES_ROOT, Icon.Path, Icon.Value) = Icon.Data
End Function

Public Sub sdkExt()
    If GetString(HKEY_CLASSES_ROOT, FileType.Path, FileType.Value) <> FileType.Data Then
        SaveString HKEY_CLASSES_ROOT, FileType.Path, FileType.Value, FileType.Data
    End If
    If GetString(HKEY_CLASSES_ROOT, Extension.Path, Extension.Value) <> Extension.Data Then
        SaveString HKEY_CLASSES_ROOT, Extension.Path, Extension.Value, Extension.Data
    End If
    If GetString(HKEY_CLASSES_ROOT, Address.Path, Address.Value) <> Address.Data Then
        SaveString HKEY_CLASSES_ROOT, Address.Path, Address.Value, Address.Data
    End If
    If GetString(HKEY_CLASSES_ROOT, Icon.Path, Icon.Value) <> Icon.Data Then
        SaveString HKEY_CLASSES_ROOT, Icon.Path, Icon.Value, Icon.Data
    End If
    ApplyRegChanges
End Sub

Public Sub sdkForgetExt()
    If GetString(HKEY_CLASSES_ROOT, FileType.Path, FileType.Value) = FileType.Data Then
        DelSetting HKEY_CLASSES_ROOT, FileType.Path, FileType.Value
    End If
    If GetString(HKEY_CLASSES_ROOT, Extension.Path, Extension.Value) = Extension.Data Then
        DelSetting HKEY_CLASSES_ROOT, Extension.Path, Extension.Value
    End If
    If GetString(HKEY_CLASSES_ROOT, Address.Path, Address.Value) = Address.Data Then
        DelSetting HKEY_CLASSES_ROOT, Address.Path, Address.Value
    End If
    If GetString(HKEY_CLASSES_ROOT, Icon.Path, Icon.Value) = Icon.Data Then
        DelSetting HKEY_CLASSES_ROOT, Icon.Path, Icon.Value
    End If
    ApplyRegChanges
End Sub
